/**********************************************************************
 * This file is Copyright 1999-2000 by Alexander E. Mohr.             *
 * In order to use any part of this file, you must comply with the    *
 * license in "LICENSE."                                              *
 *********************************************************************/

#include "headers.h"

int main(int argc, char **argv)
{
  CONFIG_DATA * config;
  UC_CURVE * uc_curve;
  ASSIGNMENT * assignment;
  int i;
  int count;

  if ( 1 )
    {
      char buf[MAX_STRING_LENGTH];
      config = malloc( sizeof( CONFIG_DATA ) );
      
      printf("Enter data file name> ");
      fgets( buf, MAX_STRING_LENGTH-1, stdin );
      if ( strlen(buf) > 0 && buf[strlen(buf)-1] == '\n' )
	buf[strlen(buf)-1] = 0;
      config->fileName = strdup(buf);
      printf("Using file name [%s].\n\n", buf );

    choose_format:
      printf("Choose a file format:\n");
      printf("1 - SPIHT (first column bit rate, second mse, third psnr).\n");
      printf("2 - First column cost in bits, second column utility.\n");
      printf("3 - First column cost in bytes, second column utility.\n");
      printf("> ");
      fgets( buf, MAX_STRING_LENGTH-1, stdin );
      config->fileFormat = atoi(buf);
      if ( config->fileFormat <= 0 || config->fileFormat > 3 )
	{ printf("Invalid file format.\n\n"); goto choose_format; }
      printf("Using format [%d].\n\n", config->fileFormat );

      // SPIHT defaults
      if ( config->fileFormat == FORMAT_SPIHT )
	{
	  config->cost_type = COST_RATE;
	  config->utility_type = UTILITY_PSNR;

	choose_psnr_mse:
	  printf("Do you want to use PSNR or MSE for utility [p/m]?\n");
	  printf("> ");
	  fgets( buf, MAX_STRING_LENGTH-1, stdin );
	  if ( *buf == 'p' || *buf == 'P' )
	    config->utility_type = UTILITY_PSNR;
	  else if ( *buf == 'm' || *buf == 'M' )
	    {
	      config->utility_type = UTILITY_MSE;
	      printf("*** NOTE: The simulator assumes utilities increase with rate, so\n");
	      printf("          MSE's will be reported as negative numbers.  Future\n");
	      printf("          versions will fix that.\n");
	    }
	  else
	    goto choose_psnr_mse;

	choose_image_width:
	  printf("Enter the image width> ");
	  fgets( buf, MAX_STRING_LENGTH-1, stdin );
	  config->image_width = atoi(buf);
	  if ( config->image_width <= 0 )
	    { printf("Invalid number.\n\n"); goto choose_image_width; }
	  printf("Using image width of %d.\n\n",
		 config->image_width);

	choose_image_height:
	  printf("Enter the image height> ");
	  fgets( buf, MAX_STRING_LENGTH-1, stdin );
	  config->image_height = atoi(buf);
	  if ( config->image_height <= 0 )
	    { printf("Invalid number.\n\n"); goto choose_image_height; }
	  printf("Using image height of %d.\n\n",
		 config->image_height);

	  config->image_frames = 1;
	  config->image_bits = 8;
	}
	  
    choose_number_descriptions:
      printf("Enter the number of packets/descriptions> ");
      fgets( buf, MAX_STRING_LENGTH-1, stdin );
      config->number_descriptions = atoi(buf);
      if ( config->number_descriptions <= 0 )
	{ printf("Invalid number.\n\n"); goto choose_number_descriptions; }
      printf("Using %d packets/descriptions.\n\n",
	     config->number_descriptions);

      // Derived values.
      config->matching = 1;
      config->symbol_size = 8;
      config->description_length = 1;
      config->number_symbols = config->number_descriptions
	* config->description_length;
      config->cost_to_use = config->number_symbols * config->symbol_size;
    }
  
  fprintf(stderr,"Reading data file.\n");
  uc_curve = read_ulp_data_file( config );

  assignment = alloc_assignment( config );

  for( i = 1; i <= config->number_descriptions; i++ )
    {
      char buf[MAX_STRING_LENGTH];
      printf("Utility when %d packets/descriptions are received (%d lost)> ",
	     i, config->number_descriptions - i);
      fgets( buf, MAX_STRING_LENGTH-1, stdin );
      assignment->guide_utility[i] = atof(buf);
      printf("Target utility for %d descriptions: %f.\n",
	     i, assignment->guide_utility[i]);
    }

  count = utilities_to_code_strength( assignment, uc_curve, config );

  for( i = 1; i <= config->number_descriptions; i++ )
    printf("%3d descriptions, target utility: %10.5f (%10.5f achieved).\n",
	   i, assignment->guide_utility[i], assignment->actual_utility[i]);

  printf("%d bytes used in each of %d packets for a total of %d bytes.\n",
	 count,
	 config->number_descriptions,
	 count * config->number_descriptions );

  return 0;
}

